(function($) {
    $.fn.mdwikiTOC = function(props) {
        var options = $.extend({
        }, props || {});

        // TOC variable will be filled with json data for table-of-contents
        var toc_jdata = '$(TOC)';
        var tpl = '<ul class="TOC"></ul>';
        var prefix_path = '';

        function insert_item(parent, data)
        {
            var li_s = '<li><a href="' + prefix_path + data.file + '#' + data.name + '">' + 
                data.text + '</a></li>';
            parent.append(li_s);
            var parent = $('li:last', parent);
            if (data.childs.length > 0) {
                parent.append('<ul></ul>');
                var ul = $('ul:last', parent);
                for (var i = 0; i < data.childs.length; i++)
                    insert_item(ul, data.childs[i]);
            }
        }
        
        return this.each(function() {
            prefix_path = $('#prefix-path').html();
            var myel = $(this);
            myel.append(tpl);
            jdata = $.parseJSON(toc_jdata);
            var ul = $('.TOC', myel)
            for (var i = 0; i < jdata.length; i++)  {
                insert_item(ul, jdata[i])
            }
        });
    };
})(jQuery);
